/*
CLASS:command_apply:command_frame
*/
#ifndef GABA_DEFINE
struct command_apply
{
  struct command_frame super;
  struct command *f;
};
extern struct lsh_class command_apply_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
static void
do_command_apply_mark(struct lsh_object *o,
  void (*mark)(struct lsh_object *o))
{
  struct command_apply *i = (struct command_apply *) o;
  mark((struct lsh_object *) i->f);
}
struct lsh_class command_apply_class =
{
  STATIC_HEADER,
  &(command_frame_class),
  "command_apply",
  sizeof(struct command_apply),
  do_command_apply_mark,
  NULL,
};
#endif /* !GABA_DECLARE */

/*
CLASS:gaba_continuation:command_continuation
*/
#ifndef GABA_DEFINE
struct gaba_continuation
{
  struct command_continuation super;
  struct lsh_object *value;
};
extern struct lsh_class gaba_continuation_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
static void
do_gaba_continuation_mark(struct lsh_object *o,
  void (*mark)(struct lsh_object *o))
{
  struct gaba_continuation *i = (struct gaba_continuation *) o;
  mark((struct lsh_object *) i->value);
}
struct lsh_class gaba_continuation_class =
{
  STATIC_HEADER,
  &(command_continuation_class),
  "gaba_continuation",
  sizeof(struct gaba_continuation),
  do_gaba_continuation_mark,
  NULL,
};
#endif /* !GABA_DECLARE */

/*
CLASS:command_2_invoke:command
*/
#ifndef GABA_DEFINE
struct command_2_invoke
{
  struct command super;
  struct command_2 *f;
  struct lsh_object *a1;
};
extern struct lsh_class command_2_invoke_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
static void
do_command_2_invoke_mark(struct lsh_object *o,
  void (*mark)(struct lsh_object *o))
{
  struct command_2_invoke *i = (struct command_2_invoke *) o;
  mark((struct lsh_object *) i->f);
  mark((struct lsh_object *) i->a1);
}
struct lsh_class command_2_invoke_class =
{
  STATIC_HEADER,
  &(command_class),
  "command_2_invoke",
  sizeof(struct command_2_invoke),
  do_command_2_invoke_mark,
  NULL,
};
#endif /* !GABA_DECLARE */

/*
CLASS:command_3_invoke_2:command
*/
#ifndef GABA_DEFINE
struct command_3_invoke_2
{
  struct command super;
  struct command_3 *f;
  struct lsh_object *a1;
  struct lsh_object *a2;
};
extern struct lsh_class command_3_invoke_2_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
static void
do_command_3_invoke_2_mark(struct lsh_object *o,
  void (*mark)(struct lsh_object *o))
{
  struct command_3_invoke_2 *i = (struct command_3_invoke_2 *) o;
  mark((struct lsh_object *) i->f);
  mark((struct lsh_object *) i->a1);
  mark((struct lsh_object *) i->a2);
}
struct lsh_class command_3_invoke_2_class =
{
  STATIC_HEADER,
  &(command_class),
  "command_3_invoke_2",
  sizeof(struct command_3_invoke_2),
  do_command_3_invoke_2_mark,
  NULL,
};
#endif /* !GABA_DECLARE */

/*
CLASS:command_3_invoke:command
*/
#ifndef GABA_DEFINE
struct command_3_invoke
{
  struct command super;
  struct command_3 *f;
  struct lsh_object *a1;
};
extern struct lsh_class command_3_invoke_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
static void
do_command_3_invoke_mark(struct lsh_object *o,
  void (*mark)(struct lsh_object *o))
{
  struct command_3_invoke *i = (struct command_3_invoke *) o;
  mark((struct lsh_object *) i->f);
  mark((struct lsh_object *) i->a1);
}
struct lsh_class command_3_invoke_class =
{
  STATIC_HEADER,
  &(command_class),
  "command_3_invoke",
  sizeof(struct command_3_invoke),
  do_command_3_invoke_mark,
  NULL,
};
#endif /* !GABA_DECLARE */

/*
CLASS:command_4_invoke_3:command
*/
#ifndef GABA_DEFINE
struct command_4_invoke_3
{
  struct command super;
  struct command_4 *f;
  struct lsh_object *a1;
  struct lsh_object *a2;
  struct lsh_object *a3;
};
extern struct lsh_class command_4_invoke_3_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
static void
do_command_4_invoke_3_mark(struct lsh_object *o,
  void (*mark)(struct lsh_object *o))
{
  struct command_4_invoke_3 *i = (struct command_4_invoke_3 *) o;
  mark((struct lsh_object *) i->f);
  mark((struct lsh_object *) i->a1);
  mark((struct lsh_object *) i->a2);
  mark((struct lsh_object *) i->a3);
}
struct lsh_class command_4_invoke_3_class =
{
  STATIC_HEADER,
  &(command_class),
  "command_4_invoke_3",
  sizeof(struct command_4_invoke_3),
  do_command_4_invoke_3_mark,
  NULL,
};
#endif /* !GABA_DECLARE */

/*
CLASS:command_4_invoke_2:command
*/
#ifndef GABA_DEFINE
struct command_4_invoke_2
{
  struct command super;
  struct command_4 *f;
  struct lsh_object *a1;
  struct lsh_object *a2;
};
extern struct lsh_class command_4_invoke_2_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
static void
do_command_4_invoke_2_mark(struct lsh_object *o,
  void (*mark)(struct lsh_object *o))
{
  struct command_4_invoke_2 *i = (struct command_4_invoke_2 *) o;
  mark((struct lsh_object *) i->f);
  mark((struct lsh_object *) i->a1);
  mark((struct lsh_object *) i->a2);
}
struct lsh_class command_4_invoke_2_class =
{
  STATIC_HEADER,
  &(command_class),
  "command_4_invoke_2",
  sizeof(struct command_4_invoke_2),
  do_command_4_invoke_2_mark,
  NULL,
};
#endif /* !GABA_DECLARE */

/*
CLASS:command_4_invoke:command
*/
#ifndef GABA_DEFINE
struct command_4_invoke
{
  struct command super;
  struct command_4 *f;
  struct lsh_object *a1;
};
extern struct lsh_class command_4_invoke_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
static void
do_command_4_invoke_mark(struct lsh_object *o,
  void (*mark)(struct lsh_object *o))
{
  struct command_4_invoke *i = (struct command_4_invoke *) o;
  mark((struct lsh_object *) i->f);
  mark((struct lsh_object *) i->a1);
}
struct lsh_class command_4_invoke_class =
{
  STATIC_HEADER,
  &(command_class),
  "command_4_invoke",
  sizeof(struct command_4_invoke),
  do_command_4_invoke_mark,
  NULL,
};
#endif /* !GABA_DECLARE */

/*
CLASS:trace_continuation:command_continuation
*/
#ifndef GABA_DEFINE
struct trace_continuation
{
  struct command_continuation super;
  const char * name;
  struct command_continuation *real;
};
extern struct lsh_class trace_continuation_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
static void
do_trace_continuation_mark(struct lsh_object *o,
  void (*mark)(struct lsh_object *o))
{
  struct trace_continuation *i = (struct trace_continuation *) o;
  mark((struct lsh_object *) i->real);
}
struct lsh_class trace_continuation_class =
{
  STATIC_HEADER,
  &(command_continuation_class),
  "trace_continuation",
  sizeof(struct trace_continuation),
  do_trace_continuation_mark,
  NULL,
};
#endif /* !GABA_DECLARE */

/*
CLASS:trace_command:command
*/
#ifndef GABA_DEFINE
struct trace_command
{
  struct command super;
  const char * name;
  struct command *real;
};
extern struct lsh_class trace_command_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
static void
do_trace_command_mark(struct lsh_object *o,
  void (*mark)(struct lsh_object *o))
{
  struct trace_command *i = (struct trace_command *) o;
  mark((struct lsh_object *) i->real);
}
struct lsh_class trace_command_class =
{
  STATIC_HEADER,
  &(command_class),
  "trace_command",
  sizeof(struct trace_command),
  do_trace_command_mark,
  NULL,
};
#endif /* !GABA_DECLARE */

